<?php
/*
 * This file is Copyright (c) 2005 by Martijn van der Kwast <mvdkwast@gmx.net>
 * and part of the Coppermine Integration plugin for WordPress.
 */

/******************************************************************************/
/*				   GENERIC SETTINGS MANAGER & FORM GENERATOR                  */
/******************************************************************************/

$settings_version = '4.3';

/*----------------------------------------------------------------------------*/
/*									SETTINGS                                  */
/*----------------------------------------------------------------------------*/

/* 0: option
 * 1: type
 * 2: default value
 * 3: section 
 * 4: depends on
 * 5: label
 * 6: description
 * 7: wp version (0: all, 1:wp15 only, 2:wp2x only)
 */

// Text translation "__('name','coppermine') in the variable $cpg_options cause errors for the research on the configuration and import user wordpress.
// Order must same label (5) that variable $test and description (6) tha variable $info

$cpg_options = array(
	/* meta */
	array( 'cpg_options_version', 	'hide',	$settings_version,	'',	'', 'Options set version',	'Version of the option set for the Coppermine Integration plugin' , 0 ),
	
	/* Database stuff */
	array( 'cpg_dbserver',	'string',		'localhost',	'database',		'',	'Server',	'Database server for the Coppermine database' , 0 ),
	array( 'cpg_dbuser', 	'string',		'',	'database',		'',	'User',	'Database user for the Coppermine database' , 0 ),
	array( 'cpg_dbpass',	'password',		'',	'database',		'',	'Password',	'Database password for the Coppermine database' , 0 ),
	array( 'cpg_dbname',	'string',		'',		'database',		'',	'Database',		'Database name for the Coppermine database' , 0 ),
	array( 'cpg_table_prefix','string',	'cpg133_','database',	'',	'Table prefix',	'Coppermine database table prefix' , 0 ),

	/* Editor integration */
	array( 'cpg_use_inserter',	'bool',	'1',	'editor',	'',	'Use image inserter',	'Display the one-click recent Coppermine image inserter above the editor.' , 0 ),
	array( 'cpg_inserter_num', 	'int',	'8',	'editor',	'cpg_use_inserter',	'Num. of recent images','Number of images to display in the image inserter.' , 0 ),
	array( 'cpg_upload_link', 	'bool',	'1',	'editor',	'',	'Display upload link', 'Place a link to upload pictures in the editor screen.' , 0 ),
	array( 'cpg_popup_upload', 		'bool',			'1',	'editor',		'cpg_upload_link',			'Use popup upload window','Display a popup window to upload pictures when the upload link is clicked. wp-upload.php needs to be present in the Coppermine directory.' , 0 ),
	array( 'cpg_selecter_link',	'bool',	'1',	'editor',	'',	'Display link to selecter',	'Place a link to the Coppermine Image selecter in the editor screen.', 0 ),
	array( 'cpg_min_level',		'user-level',	'2','editor',	'',	'Min. User level for editor integration',	'Minimal user-level required to see Coppermine Integration Plugin elements in the editor.', 1 ),	
	array( 'cpg_display_all_pics',	'bool',	'0',	'editor',	'',	'Display everybody\'s pictures','Display all the recent pictures in the inserter bar, not only the pictures you own.', 0 ),

	/* Options */
	array( 'cpg_charset','charset','iso-8859-1', 'options', '', 'Character encoding', 'Character encoding used in Coppermine.' , 0 ),	array( 'cpg_link_style', 		'link-style',	'g',			'options',		'',		'Action when image is clicked',
		'Select what happens when you click on an image.', 0 ),
	array( 'cpg_image_style', 'bool',	'0', 'options','',	'Use div-tag for displaying image? (no=img-tag)',	'How the image will be displayed, streched img or cropped div (all images will have the same size and orientation)', 0 ),

	array( 'cpg_div_size_x',		'int',		'100',	'options',	'',	 	'div width',	'div width' , 0 ),
	array( 'cpg_div_size_y',		'int',		'75',	'options',	'',	 	'div height',	'div height' , 0 ),
	array( 'cpg_div_options',		'string',		'',	'options',	'',	 	'background extra',	'extra options which will be added to background style tag' , 0 ),
	array( 'cpg_show_filename', 		'bool',	'1',	'options',	'',		'Display filename',	'Show filename / description below image', 0 ),
	array( 'cpg_upload_user_id',		'int',		'',				'options',		'',	 	'Coppermine user id',	'Userid for just selecting the own pictures. (empty for all)' , 0 ),
	array( 'cpg_upload_user',		'string',		'',	'options',		'',	 	'Coppermine user',	'Username for automatic login, not used if user integration if enabled.' , 0 ),
	array( 'cpg_upload_pass',		'password',		'',	'options',		'',		'Coppermine password', 'Password for automatic login, not used if user integration if enabled.' , 0 ),
	array( 'cpg_use_dewplayer','bool','1','options', '', 'Use DewPlayer for Mp3', 	'Use Dew\'s lightweight player (flash) for Mp3.' , 0 ),
	array( 'cpg_use_shadows','bool','0','options', '', 'Display a shadow around pictures','Display a shadow around pictures.' , 0 ),
	array( 'cpg_filter_excerpt',	'bool',	'1', 'options',	'',	'Include an image in excerpts',	"If set to true, the first image found in the post will be included in the excerpt. If set to false, the images and tags will be hidden. The CSS class 'cpg-excerpt' can be used to control the layout of the picture.", 0),
	
	/* Lightbox */
	array( 'cpg_lightbox_title','bool','0','lightbox', '', 'Display title',	'Display title in Lightbox.' , 0 ),
	array( 'cpg_lightbox_caption','bool','0','lightbox', '', 'Display caption',	'Display caption in Lightbox.' , 0 ),
	array( 'cpg_lightbox_dateadded','bool','0','lightbox', '', 'Display date added', 'Display date added in Lightbox.' , 0 ),	
	array( 'cpg_lightbox_datetime','bool','0','lightbox', '', 'Display date time',	'Display date time in Lightbox.' , 0 ),
	array( 'cpg_lightbox_datedigitized','bool','0','lightbox', '', 'Display date digitized', 'Display date digitized in Lightbox.' , 0 ),
	array( 'cpg_lightbox_dimensions','bool','0','lightbox', '', 'Display dimensions',	'Display dimensions in Lightbox.' , 0 ),
	array( 'cpg_lightbox_filesize','bool','0','lightbox', '', 'Display file size', 'Display file size in Lightbox.' , 0 ),
	array( 'cpg_lightbox_make','bool','0','lightbox', '', 'Display make',	'Display make in Lightbox.' , 0 ),
	array( 'cpg_lightbox_model','bool','0','lightbox', '', 'Display model',	'Display model in Lightbox.' , 0 ),
	array( 'cpg_lightbox_focal','bool','0','lightbox', '', 'Display focal length','Display focal lenght in Lightbox.' , 0 ),
	array( 'cpg_lightbox_iso','bool','0','lightbox', '', 'Display ISO',	'Display ISO in Lightbox.' , 0 ),
	array( 'cpg_lightbox_meteringmode','bool','0','lightbox', '', 'Display metering mode','Display metering mode in Lightbox.' , 0 ),
	array( 'cpg_lightbox_fnumber','bool','0','lightbox', '', 'Display FNumber','Display FNumber in Lightbox.' , 0 ),
	array( 'cpg_lightbox_maxaperturevalue','bool','0','lightbox', '', 'Display Max Aperture','Display Max Aperture in Lightbox.' , 0 ),
	array( 'cpg_lightbox_flash','bool','0','lightbox', '', 'Display flash',	'Display flash in Lightbox.' , 0 ),
	array( 'cpg_lightbox_exposuretime','bool','0','lightbox', '', 'Display exposure time', 'Display exposure time in Lightbox.' , 0 ),
	array( 'cpg_lightbox_orientation','bool','0','lightbox', '', 'Display Orientation', 'Display Orientation in Lightbox.' , 0 ),
	array( 'cpg_lightbox_filesource','bool','0','lightbox', '', 'Display File Source', 'Display File Source in Lightbox.' , 0 ),
	array( 'cpg_lightbox_compression','bool','0','lightbox', '', 'Display compression', 'Display compression in Lightbox.' , 0 ),
	array( 'cpg_lightbox_scenetype','bool','0','lightbox', '', 'Display scene type', 'Display scene type in Lightbox.' , 0 ),
	array( 'cpg_lightbox_exposureprogram','bool','0','lightbox', '', 'Display exposure program', 'Display exposure program in Lightbox.' , 0 ),
	array( 'cpg_lightbox_resolution','bool','0','lightbox', '', 'Display resolution program', 'Display resolution in Lightbox.' , 0 ),
	array( 'cpg_lightbox_hits','bool','0','lightbox', '', 'Display hits, rating and votes',	'Display hits, rating and votes in Lightbox.' , 0 ),
	array( 'cpg_lightbox_comments','bool','0','lightbox', '', 'Display comments',	'Display comments in Lightbox.' , 0 ),
	array( 'cpg_lightbox_smilies','bool','0','lightbox', '', 'Show bar Smilies',	'Show bar Smilies in Lightbox' , 0 ),
	array( 'cpg_lightbox_fullsize','bool','0','lightbox', '', 'Display link full size',	'Display comments in Lightbox.' , 0 ),
	array( 'cpg_lightbox_album','bool','0','lightbox', '', 'Display link go to album','Display comments in Lightbox.' , 0 ),	
  array( 'cpg_email_comment_notification','bool','0','lightbox', '', 'Notify the administrator','Notify the administrator of any new comment' , 0 ),

	/* User Integration */
	array( 'cpg_integrate_users',	'bool',		'0',	'integration',	'',	'Integrate users',	'Enable/Disable integration of Wordpress and Coppermine users. Does not work with Coppermine 1.4', 0 ),
	array( 'cpg_auto_create_users',	'bool',		'1',	'integration',	'cpg_integrate_users',	'Auto-create users',	'Automatically create a Coppermine user for every WordPress user at login.' , 0 ),
	array( 'cpg_auto_create_album',	'bool',		'1',	'integration',	'cpg_integrate_users',	'Auto-create albums',	'Automatically create a default album for every WordPress user at login. ', 0 ),
	array( 'cpg_user_group', 	'cpg-group',	'2',    'integration',	'cpg_integrate_users',	'Coppermine group',	'Coppermine group WordPress users should be added to. ', 0 ),
	array( 'cpg_user_min_level_create', 'user-level','2',	'integration',	'cpg_integrate_users',	'Min. User level',	'Minimum user-level required to get a Coppermine login.' , 1 ),
	array( 'cpg_auto_login',	'bool',		'1',	'integration',	'cpg_integrate_users',	'Automatically login',	'Automatically login to Coppermine when you login to WordPress.' , 0 ),
	array( 'cpg_remote_login', 'bool',	'1','integration','cpg_auto_login',	'Remote login',	'You need this option if you want to automatically login to a Coppermine server located on a remote server. ' , 1 ),
);



/*----------------------------------------------------------------------------*/
/*							  SETTING MANIPULATION                            */
/*----------------------------------------------------------------------------*/

/* return true iff an installation is found */
function settings_are_installed()
{
	return get_option('cpg_options_version');
}

/* write default values for parameters to options table */
function settings_install()
{
	global $cpg_options;

	foreach ($cpg_options as $option) {
		add_option( $option[0], $option[2], $option[3] );
	}
}

/* add settings that don't exist yet */
function settings_update()
{
	global $cpg_options;

	foreach ($cpg_options as $option) {
		if (false===get_option($option[0])) {
			add_option( $option[0], $option[2], $option[3] );
		}
	}
}


/* remove all settings from database, is this script polite or what ? */
function settings_uninstall()
{
	global $cpg_options;

	foreach ($cpg_options as $option) {
		delete_option($option[0]);
	}
}

/* reset settings to defaults */
function settings_reset()
{
	global $cpg_options;
	
	foreach ($cpg_options as $option) {
		delete_option($option[0]);
		add_option( $option[0], $option[2], $option[3] );
	}
}

/* save all settings to database from $_POST */
function settings_save($cpg_options)
{
	#global $cpg_options;

	foreach ($cpg_options as $option) {
		if (isset($_POST[$option[0]])) {
			update_option($option[0], $_POST[$option[0]]);
		}
	}
}


/*----------------------------------------------------------------------------*/
								   /* Form */
/*----------------------------------------------------------------------------*/

function form_elt_user_level($option)
{
	$value = get_option($option['0']);
	
	print "<select id=\"$option[0]\" name=\"$option[0]\">";

	if ($value==0) {
		print '<option value="0" selected="selected">'.__('Everybody','coppermine').'</option>';
	} else {
		print '<option value="0">'.__('Everybody','coppermine').'</option>';
	}
		
	for ($i=1;$i<11;$i++) {
		$selected = ($value==$i) ? ' selected="selected"' : '';
		print "<option value=\"$i\" $selected>$i</option>";
	}
		
	if ($value>10) {
		print '<option value="0" selected="selected">'.__('Nobody','coppermine').'</option>';
	} else {
		print '<option value="0">'.__('Nobody','coppermine').'</option>';
	}
	
	print '</select>';
}

// hash: key => label
function _form_elt_dropdown($option, $hash)
{
	print "<select id=\"$option[0]\" name=\"$option[0]\">";
	$default = get_option($option[0]);

	foreach ($hash as $k => $v) {
		$selected = ($default==$k) ? ' selected="selected"' : '';
		print "<option value=\"$k\" $selected>$v</option>";
	}

	print '</select>';
}

// hash: key => array( label, ..,  .. )

function _form_elt_dropdown_arr($option, $hash)
{
	print "<select id=\"$option[0]\" name=\"$option[0]\">";
	$default = get_option($option[0]);

	foreach ($hash as $k => $v) {
		$selected = ($default==$k) ? ' selected="selected"' : '';
		print "<option value=\"$k\" $selected>$v[0]</option>";
	}

	print '</select>';
}

function form_elt_link_style($option)
{
	global $cpg_link_styles;
	_form_elt_dropdown_arr($option, $cpg_link_styles);
}


function form_elt_charset($option)
{
	$charsets = array(
		'windows-1256' => 'Arabic' ,
		'iso-8859-4' => 'Baltic' ,
		'iso-8859-2' => 'Central European' ,
		'euc-cn' => 'Chinese Simplified' ,
		'big5' => 'Chinese Traditional' ,
		'koi8-r' => 'Cyrillic' ,
		'iso-8859-7' => 'Greek' ,
		'iso-8859-8-i' => 'Hebrew' ,
		'x-mac-icelandic' => 'Icelandic' ,
		'euc-jp' => 'Japanese' ,
		'euc-kr' => 'Korean' ,
		'iso-8859-3' => 'Maltese' ,
		'windows-874 ' => 'Thai' ,
		'iso-8859-9' => 'Turkish' ,
		'utf-8' => 'Unicode' ,
		'windows-1258' => 'Vietnamese' ,
		'iso-8859-1' => 'Western' ,
	);

	_form_elt_dropdown($option, $charsets);
}

function form_elt_user_group($option)
{
	global $cpg_cmdb;

	if ($cpg_cmdb==false || $cpg_cmdb->unavailable) {
		form_elt_int($option);
	} else {
		$groups=array();
		$dbgroups = @cpg_db_get_groups();
		if ($dbgroups) {
			foreach($dbgroups as $dbgroup) {
				$groups[$dbgroup->group_id] = $dbgroup->group_name;
			}
			_form_elt_dropdown($option, $groups);
		} else {
			form_elt_int($option);
		}
	}
}



function form_elt_int($option)
{
	$val=get_option($option[0]);
	print "<input id=\"$option[0]\" name=\"$option[0]\" type=\"text\" class=\"button\" value=\"$val\" />";
}

function form_elt_bool($option)
{
	$val=get_option($option[0]);
	if ($val) {
		print "<input id=\"$option[0]\" type=\"radio\" name=\"$option[0]\" class=\"button\" value=\"1\" checked=\"checked\">".__('Yes','coppermine')."</input>";
		print "<input id=\"$option[0]-no\" type=\"radio\" name=\"$option[0]\" class=\"button\" value=\"0\">".__('No','coppermine')."</input>";
	} else {
		print "<input id=\"$option[0]\" type=\"radio\" name=\"$option[0]\" class=\"button\" value=\"1\">".__('Yes','coppermine')."</input>";
		print "<input id=\"$option[0]-no\" type=\"radio\" name=\"$option[0]\" class=\"button\" value=\"0\" checked=\"checked\">".__('No','coppermine')."</input>";
	}
}

function form_elt_password($option)
{
	$val=get_option($option[0]);
	print "<input id=\"$option[0]\" name=\"$option[0]\" type=\"password\" class=\"button\" value=\"$val\" />";
}

function form_elt_string($option)
{
	$val=get_option($option[0]);
	print "<input id=\"$option[0]\" name=\"$option[0]\" type=\"text\" class=\"button\" value=\"$val\" />";
}
								   
/* 0: option
 * 1: type
 * 2: default value
 * 3: section 
 * 4: depends on
 * 5: label
 * 6: description 
 * 7: wp version (0: all, 1:wp15 only, 2:wp2x only)
 */


 
 
function config_section($cpg_options,$section)
{
	#global $cpg_options;
	
  // variable translation
  // Here because the search function and import user does not
  // Order same between ($test and $info) and $cpg_options
  $text = array(
    /* Database stuff */
    'database' => array('',
    __('Server','coppermine'),
    __('User','coppermine'),
    __('Password','coppermine'),
    __('Database','coppermine'),
    __('Table prefix','coppermine')),
    /* Editor integration */
    'editor' => array('',
    __('Use image inserter','coppermine'),
    __('Num. of recent images','coppermine'),
    __('Display upload link','coppermine'),
    __('Use popup upload window','coppermine'),
    __('Display link to selecter','coppermine'),
    __('Min. User level for editor integration','coppermine'),
    __('Display everybody\'s pictures','coppermine')),
    /* Options */
    'options' => array('',
    __('Character encoding','coppermine'),
    __('Action when image is clicked','coppermine'),
    __('Use div-tag for displaying image? (no=img-tag)','coppermine'),
    __('width','coppermine'),
    __('height','coppermine'),
    __('background extra','coppermine'),
    __('Display filename','coppermine'),
    __('Coppermine user id','coppermine'),
    __('Coppermine user','coppermine'),
    __('Coppermine password','coppermine'),
    __('Use DewPlayer for Mp3','coppermine'),
    __('Display a shadow around pictures','coppermine'),
    __('Include an image in excerpts','coppermine')),
    
    /* Options lightbox */
    'lightbox' => array('',
    __('Title','coppermine'),
    __('Caption','coppermine'),
    __('DateTime added','coppermine'),
    __('DateTime','coppermine'),
    __('DateTime digitized','coppermine'),
    __('Dimensions of the image','coppermine'),
    __('File size','coppermine'),
    __('Make','coppermine'),
    __('Model','coppermine'),
    __('Focal length','coppermine'),
    __('ISO','coppermine'),
    __('Metering mode','coppermine'),
    __('FNumber','coppermine'),
    __('Max Aperture','coppermine'),
    __('Flash','coppermine'),
    __('Exposure time','coppermine'),
    __('Orientation','coppermine'),
    __('File Source','coppermine'),
    __('Compression','coppermine'),
    __('Scene type','coppermine'),
    __('Exposure program','coppermine'),
    __('Resolution','coppermine'),
    __('Hits, rating and votes','coppermine'),
    __('Comments','coppermine'),
    __('Bar Smilies','coppermine'),
    __('Link full size','coppermine'),
    __('Link go to album','coppermine'),
    __('Notify administrator for new comment','coppermine')),
    /* User Integration */
    'integration' => array('',
    __('Integrate users','coppermine'),
    __('Auto-create users','coppermine'),
    __('Auto-create albums','coppermine'),
    __('Coppermine group','coppermine'),
    __('Min. User level','coppermine'),
    __('Automatically login','coppermine'),
    __('Remote login','coppermine'))
  );
  /* Detailed information */
  $info = array(
    /* Database stuff */
    'database' => array('',
    __('Database server for the Coppermine database','coppermine'),
    __('Database user for the Coppermine database','coppermine'),
    __('Database password for the Coppermine database','coppermine'),
    __('Database name for the Coppermine database','coppermine'),
    __('Coppermine database table prefix','coppermine')),
    /* Editor integration */
    'editor' => array('',
    __('Display the one-click recent Coppermine image inserter above the editor.','coppermine'),
    __('Number of images to display in the image inserter.','coppermine'),
    __('Place a link to upload pictures in the editor screen.','coppermine'),
    __('Display a popup window to upload pictures when the upload link is clicked. wp-upload.php needs to be present in the Coppermine directory.','coppermine'), 	
    __('Place a link to the Coppermine Image selecter in the editor screen.','coppermine'),
    __('Minimal user-level required to see Coppermine Integration Plugin elements in the editor.','coppermine'),
    __('Display all the recent pictures in the inserter bar, not only the pictures you own.','coppermine')),
    /* Options */
    'options' => array('',
    __('Character encoding used in Coppermine.','coppermine'),
    __('Select what happens when you click on an image.','coppermine'),
    __('How the image will be displayed, streched img or cropped div (all images will have the same size and orientation)','coppermine'),
    __('Width of the thumbnail (leave blank for size by default)','coppermine'),
    __('Height of the thumbnail (leave blank for size by default)','coppermine'),
    __('extra options which will be added to background style tag','coppermine'),
    __('Show filename / description below image','coppermine'),
    __('Userid for just selecting the own pictures. (empty for all)','coppermine'),
    __('Username for automatic login, not used if user integration if enabled.','coppermine'),
    __('Password for automatic login, not used if user integration if enabled.','coppermine'),
    __('Use Dew\'s lightweight player (flash) for Mp3.','coppermine'),
    __('Display a shadow around pictures.','coppermine'),
    __('If set to true, the first image found in the post will be included in the excerpt. If set to false, the images and<br /> tags will be hidden. The CSS class \'cpg-excerpt\' can be used to control the layout of the picture. Note: The theme must support this option.','coppermine')),
    /* Options lightbox */
    'lightbox' => array('',
    __('Display title in Lightbox','coppermine'),
    __('Display caption in Lightbox','coppermine'),
    __('Display Datetime added in Lightbox','coppermine'),
    __('Display DateTime in Lightbox','coppermine'),
    __('Display DateTime digitized in Lightbox','coppermine'),
    __('Display dimensions of the original picture in Lightbox','coppermine'),
    __('Display file size of the original picture in Lightbox','coppermine'),
    __('Display make in Lightbox','coppermine'),
    __('Display model in Lightbox','coppermine'),
    __('Display focal lengh in Lightbox','coppermine'),
    __('Display ISO in Lightbox','coppermine'),
    __('Display metering mode in Lightbox','coppermine'),
    __('Display FNumber in Lightbox','coppermine'),
    __('Display max aperture in Lightbox','coppermine'),
    __('Display flash in Lightbox','coppermine'),
    __('Display exposure time in Lightbox','coppermine'),
    __('Display orientation in Lightbox','coppermine'),
    __('Display file source in Lightbox','coppermine'),
    __('Display compression in Lightbox','coppermine'),
    __('Display scene type in Lightbox','coppermine'),
    __('Display exposure program in Lightbox','coppermine'),
    __('Display resolution in Lightbox','coppermine'),
    __('Display hits, rating and votes in Lightbox','coppermine'),
    __('Display comments in Lightbox','coppermine'),
    __('Display bar Smilies in Lightbox','coppermine'),
    __('Display link full size in Lightbox','coppermine'),
    __('Display link go to album in Lightbox','coppermine'),
    __('Notify administrator for all new comment on the image','coppermine')),
    /* User Integration */
    'integration' => array('',
    __('Enable/Disable integration of Wordpress and Coppermine users. Does not work with Coppermine 1.4','coppermine'),
    __('Automatically create a Coppermine user for every WordPress user at login.','coppermine'),
    __('Automatically create a default album for every WordPress user at login. ','coppermine'),
    __('Coppermine group WordPress users should be added to. ','coppermine'),
    __('Minimum user-level required to get a Coppermine login.','coppermine'),
    __('Automatically login to Coppermine when you login to WordPress.','coppermine'),
    __('You need this option if you want to automatically login to a Coppermine server located on a remote server. ','coppermine'))
  );


	
	$wp_ver = function_exists('get_role') ? 2 : 1;
	
	echo '<table cellspacing="2" cellpadding="5" class="optiontable editform" width="100%">';

	foreach($cpg_options as $option)
	{
		if ($option[3] != $section)
			continue;

		if ($option[7] && $option[7]!=$wp_ver) {
			continue;
		}
		
    $x = $x + 1;
		print "<tr valign=\"top\"><th  style=\"width: 50%\" align=\"right\"><a href=\"javascript:;\" class=\"info\"><span>".$info[$section][$x]."</span>".$text[$section][$x]."</a>:</th><td class=\"form-inputs\">";
		
	//	print "<tr><td><span class=\"help-link\" onClick=\"alert('".$info[$section][$x]."')\">?</span></td><td class=\"form-labels\" align=\"right\">".$text[$section][$x].":</td><td class=\"form-inputs\">";
/*
help link
<td width='33%'><span class=\"help-link\" onClick=\"alert('$option[6]')\">?</span></td>
*/
		/* this is an ugly switch, because PHP is an ugly (but often
		 * efficient) language.
		 * There is no way to put references to functions in an array except
		 * referring to them by name and using eval. Using the PHP parser
		 * just to call a function is of course overkill and slow.  */
		
		switch($option[1]) {
			case '':
				form_elt_user_level($option);
				break;

			case 'link-style':
				form_elt_link_style($option);
				break;

			case 'charset':
				form_elt_charset($option);
				break;
			
			case 'cpg-group':
				form_elt_user_group($option);
				break;
				
			case 'int':
				form_elt_int($option);
				break;

			case 'bool':
				form_elt_bool($option);
				break;

			case 'password':
				form_elt_password($option);
				break;
			
			default:
			case 'string':
				form_elt_string($option);
				break;
		}
		print '</td></tr>';
	}

	echo '</table>';
}


function config_form($cpg_options)
{
	global $CPG_CONFIG;
	
	
print '<form method="POST">';

?>
	<div>
	<fieldset class="options">
		<legend><?PHP _e('Connection','coppermine'); ?></legend>
		<div style="float: left; background: #EAF3FA; padding: 10px; margin: 10px; width: 85%" >
			<?PHP _e('These values must be the same as in <i>config.inc.php</i>, which is located in your Coppermine-Folder in the <i>include</i> subfolder.<br><br>
			WordPress is able to automaticaly fill in these values (only works if WordPress and Coppermine are installed on the same domain).','coppermine'); ?><br><br>
		<div id="test-result-span" style="background: #F5FCFD; margin: 0px; padding: 10px;">
				<a href="javascript:ajax_search_config('<?php echo $_SERVER[DOCUMENT_ROOT]; ?>');"><?PHP _e('search config','coppermine'); ?></a>
		</div>
		</div>
		<div style="width: 85%; float: left;">
			<?php config_section($cpg_options,'database'); ?>
			<div align="right">
				<input type="button" class="button" onclick="open_checkdb_popup();" value="<?PHP _e('Test connection','coppermine'); ?>"/>
				<input type="submit" class="button" value="<?PHP _e('Save Settings','coppermine'); ?>" name="save1" />
			</div>
		</div>
		
	</fieldset>
	</div>

	<?php
		if (isset($CPG_CONFIG['version'])) {
	?>

	<div>
	<fieldset class="options">
		<legend><?PHP _e('Basic Settings','coppermine'); ?></legend>
		<div style="float: left; background: #EAF3FA; padding: 10px; margin: 10px; width: 85%">
      <?PHP _e('Set the default settings used by the plugin. These can be customized to each image in the message editor.','coppermine'); ?>
		</div>
		<div style="width: 85%; float: left">
			<?php config_section($cpg_options,'options'); ?>
		</div>
	</fieldset>
	</div>
	
	<div>
	<fieldset class="options">
		<legend><?PHP _e('Editor Integration','coppermine'); ?></legend>
		<div style="float: left; background: #EAF3FA; padding: 10px; margin: 10px; width: 85%">
			<?php
				if (function_exists('get_role')) {
				?>
				<?PHP _e('To choose which users can use the Inserter Bar, please use Owen Winkler\'s <a href="Role Manager">http://redalt.com/wiki/Role+Manager</a>. By default, the Administrators, Editors, Authors and Contributors can see the Inserter bar.','coppermine'); ?>
				<?php
				}
			?>
		</div>
		<div style="width: 85%; float: left">
			<?php config_section($cpg_options,'editor'); ?>
			<p align="right">
				<input type="submit" class="button" value="<?PHP _e('Save Settings','coppermine'); ?>" name="save" />
			</p>
		</div>
	</fieldset>
	</div>

		<div>
	<fieldset class="options">
		<legend><?PHP _e('Settings for lightbox (Active option only if used for images)','coppermine'); ?></legend>
		<div style="float: left; background: #EAF3FA; padding: 10px; margin: 10px; width: 85%">
      <?PHP _e('Parameters defining the options to be displayed in the lightbox window if this option is activated. You may also be advised of any new comments. (The Lightbox own Coppermine must be installed for this to work. Do not work with other versions.)','coppermine'); ?>
		</div>
		<div style="width: 85%; float: left">
			<?php config_section($cpg_options,'lightbox'); ?>
		</div>
	</fieldset>
	</div>

	<div>
	<fieldset class="options">
		<legend><?PHP _e('User Integration','coppermine'); ?></legend>

		<?php
		if ($CPG_CONFIG['version'] < 140) {
		?>

		<div style="width: 85%; float: left;">
			<p><b><?PHP _e('Disclaimer: As far as I know, this plugin hasn\'t caused any damage to any gallery yet. But to enable user integration, it needs to modify the Coppermine database. This is not supported by the Coppermine team. So please, backup your data before you proceed','coppermine'); ?>.</b></p>
			<p><?PHP _e('In a many situations, user integration is not required. You can use pictures in WordPress and upload them to Coppermine without it. So only enable it if you need one of these functions:','coppermine'); ?>
				<ul>
					<li><?PHP _e('You want to automatically login to Coppermine when you login to WordPress.','coppermine'); ?></li>
					<li><?PHP _e('You share your blog with other users and want them to have personal Coppermine accounts.','coppermine'); ?></li>
					<li><?PHP _e('You want registered users to be able to comment on your pictures as well as on your posts.','coppermine'); ?></li>
				</ul>
			</p>
			<p><?PHP _e('To activate user integration, two things need to be done:','coppermine'); ?>
				<ol>
					<li><?PHP _e('You need to update some files in the Coppermine installation. You will have to copy the modified files from the plugin\'s package to your Coppermine installation manually.','coppermine'); ?></li>
					<li><?PHP _e('The Coppermine database needs to be upgraded. Use the following button to see the current status of your database.','coppermine'); ?></li>
				</ol>
				<div class="section-buttons">
					<input type="button" class="button" onclick="open_checkui_popup();" value="<?PHP _e('Test Database','coppermine'); ?>"/>
					<br/>
				</div>
				<div class="test-result"><span id="checkdb-result-span"></span></div>
			</p>	
		</div>	
		<?php
		}
		?>
	</fieldset>
	</div>

	<div>
	<fieldset class="options">
		<?php
		if ($CPG_CONFIG['version'] < 140) {
		?>
		<legend><?PHP _e('Database','coppermine'); ?></legend>
		<div style="width: 85%; float: left;">
			<h4><?PHP _e('Upgrade','coppermine'); ?></h4>
			<p><?PHP _e('Use this button to upgrade the database. This will alter Coppermine\'s user table.','coppermine'); ?> </p> 
			<div class="section-buttons">
				<input type="button" class="button" onclick="open_updatedb_popup()" value="<?PHP _e('Upgrade database','coppermine'); ?>"/><br/>
			</div>
			<div class="test-result"><span id="updatedb-result-span"></span></div>
		</div>
		<div style="width: 85%; float: left;">
			<h4><?PHP _e('Restore','coppermine'); ?></h4>
			<p><?PHP _e('If you want to disable user integration, you can restore the users table to the state it was in before the database upgrade. This will delete all users that were imported from WordPress!','coppermine'); ?></p>
			<div class="section-buttons">
				<input type="button" class="button" onclick="open_restoredb_popup()" value="<?PHP _e('Restore backup table','coppermine'); ?>"/>
				<br/>
			</div>
			<div class="test-result"><span id="restoredb-result-span"></span></div>
		</div>
		<?php
		}	// end if version < 140
		?>
	</fieldset>
	</div>

	<div>
	<fieldset class="options">
		<legend><?PHP _e('User Integration Settings','coppermine'); ?></legend>
		<div style="float: left;  background: #EAF3FA; padding: 10px; margin: 10px; width: 85%">
				<?php
				if ($CPG_CONFIG['version'] < 140) {
				?>
				<?PHP _e('Only activate "integrate users" if the database upgrade was successful, or you will get database error messages in WordPress.','coppermine'); ?>
				<?php
				}
				if (function_exists('get_role')) {
				?>
				<br><br><?PHP _e('To choose which users share sessions with Coppermine (single login), please use Owen Winkler\'s <a href="Role Manager">http://redalt.com/wiki/Role+Manager</a>. By default, the Administrators, Editors, Authors and Contributors are set to auto-login.','coppermine'); ?> 
				<?php
				}
				?>
			</div>
			<div style="width: 85%; float: left;">
				<?php config_section($cpg_options,'integration'); ?>
				<div align="right">
					<input type="submit" class="button" value="<?PHP _e('Save Settings','coppermine'); ?>" name="save2" />
				</div>
			</div>
			
	</fieldset>
	</div>

	<div>
	<fieldset class="options">				
			<legend><?PHP _e('Import Users','coppermine'); ?></legend>
			<div style="float: left;  background: #EAF3FA; padding: 10px; margin: 10px; width: 85%">
			<?PHP _e('Use this button to import users from WordPress into Coppermine.','coppermine'); ?>
			<?php if(function_exists('get_role')) { ?>
			<br><br><?PHP _e('This will only import users with a user level greater or equal to Min. User level (don\'t forget to press "Save Settings" before you use it).','coppermine'); ?>
			<?php } else { ?>
			<br><br><?PHP _e('This will import all users that have the role Administrator, Editor, Author or Contributor. (don\'t forget to press "Save Settings" before you use it).','coppermine'); ?>
			<?php } ?>
			<br><br><?PHP _e('If you don\'t use this, the users will be automatically imported when they login to WordPress if "Auto-create users" is enabled.','coppermine'); ?>
			</div>
			<div style="width: 85%;" align="right">
				<input type="button" class="button" onclick="open_import_users_popup()" value="<?PHP _e('Import WordPress Users','coppermine'); ?>"/>
				<div class="test-result"><span id="import-users-result-span"></span></div>
			</div>
	</fieldset>
	</div>

	<div>
	<fieldset class="options">
		<legend><?PHP _e('Settings Management','coppermine'); ?></legend>
		<div style="width: 85%;" align="right">
				<input type="submit" class="button" value="<?PHP _e('Reset Settings','coppermine'); ?>" name="reset" />
				<input type="submit" class="button" value="<?PHP _e('Uninstall','coppermine'); ?>" name="uninstall" />
		</div>
		</fieldset>
	</div>

	</form>

<?php
	}	// end if version set
}






/******************************************************************************/
/*								 IMPLEMENTATION                               */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/*									  HTML                                    */
/*----------------------------------------------------------------------------*/

function html_head()
{
?>
  <link rel="stylesheet" href="<?php echo get_settings('siteurl'); ?>/wp-content/plugins/coppermine/coppermine.css" type="text/css" />
  <script type="text/javascript" src="script_infos.js"></script>
	<script language="javascript" type="text/javascript">
function mkuri(action)
{
	var server=escape(document.getElementById('cpg_dbserver').value);
	var user=escape(document.getElementById('cpg_dbuser').value);
	var pass=escape(document.getElementById('cpg_dbpass').value);
	var db=escape(document.getElementById('cpg_dbname').value);
	var prefix=escape(document.getElementById('cpg_table_prefix').value);
	return '../wp-content/plugins/coppermine/coppermine-config.php?&action='+action+'&s='+server+'&u='+user+'&p='+pass+'&db='+db+'&px='+prefix;
}
	
function open_checkdb_popup() {
	new Ajax.Request(mkuri('checkdb'),
		{
			onSuccess: function(t)
			{
				$('test-result-span').innerHTML = t.responseText;
			}
		}
	);
}

function ajax_search_config(root) {
	new Ajax.Request(mkuri('searchcfg')+"&root="+root,
		{
			onSuccess: function(t)
			{
				$('test-result-span').innerHTML = t.responseText;
			}
		}
	);
}
function ajax_open_config(file) {
	new Ajax.Request(mkuri('opencfg')+"&file="+file,
		{
			onSuccess: function(t)
			{
				$('test-result-span').innerHTML = t.responseText;
			}
		}
	);
}

function open_checkui_popup() {
	window.open(mkuri('checkui'),'checkui','scrollbars=no,status=no,width=10,height=10');
}

function open_updatedb_popup() {
	window.open(mkuri('updatedb'),'updatedb','scrollbars=no,status=no,width=10,height=10');
}

function open_restoredb_popup() {
	window.open(mkuri('restoredb'),'restoredb','scrollbars=no,status=no,width=10,height=10');
}

function open_import_users_popup() {
	window.open(mkuri('import-users'), 'import-users', 'scrollbars=no,status=no,width=10,height=10');
}

function ajax_copy_config()
{
	$('cpg_dbserver').style.backgroundColor = "#99ff99";
	$('cpg_dbuser').style.backgroundColor = "#99ff99";
	$('cpg_dbpass').style.backgroundColor = "#99ff99";
	$('cpg_dbname').style.backgroundColor = "#99ff99";
	$('cpg_table_prefix').style.backgroundColor = "#99ff99";
	$('cpg_dbserver').value = $('ajax_cpg_dbserver').value;
	$('cpg_dbuser').value = $('ajax_cpg_dbuser').value;
	$('cpg_dbpass').value = $('ajax_cpg_dbpass').value;
	$('cpg_dbname').value = $('ajax_cpg_dbname').value;
	$('cpg_table_prefix').value = $('ajax_cpg_table_prefix').value;
}
	
	</script>
<?php
}


/*----------------------------------------------------------------------------*/
/*								 POPUP WINDOWS                                */
/*----------------------------------------------------------------------------*/

function insert_write_span_js( $id, $msg, $close )
{
	global $CPG_CONFIG;

	$spans = array( 'test-result-span', 'checkdb-result-span', 
					'updatedb-result-span', 'restoredb-result-span', 
					'import-users-result-span' );

	$msg = str_replace("'",'&apos;',$msg);
	?>
	<script language="javascript" type="text/javascript">
		var obj=null;
			<?php	foreach( $spans as $span ) { ?>
			obj=opener.document.getElementById('<?php echo $span; ?>');
			if (obj) obj.innerHTML = '';
			<?php	} ?>
	
		var span=opener.document.getElementById('<?php echo $id; ?>');	
		span.innerHTML = '<?php echo $msg; ?>';
		<?php if ($close) { ?>
		window.close();
		<?php } ?>
	</script>
<?php
}

/* find coppermineinstallation */
function ajax_search_config($root)
{

	exec('find '.$root.' -name config.inc.php',$o);
	if(count($o)==0) 
	{
		echo __('no <i>config.inc.php</i> has been found in <i>','Coppermine').$root.'</i><br>';
		$path_objects_old = explode("/",$root);
		for($i=0;$i<count($path_objects_old)-2;$i++)
		{
			$path_objects_new[] = $path_objects_old[$i];
		}
		$root = implode("/",$path_objects_new);
		echo '<br>'.__('search below (doesn\'t need to work)','coppermine').'<br><a href="javascript:ajax_search_config(\''.$root.'\')">'.str_replace($_SERVER[DOCUMENT_ROOT],'',$root).'</a>';
	} else {
		echo __('found these files, please select one','coppermine').'<br>';
	}
	foreach($o as $value)
	{
		echo '<a href="javascript:ajax_open_config(\''.$value.'\');">'.str_replace($_SERVER[DOCUMENT_ROOT],'',$value).'</a><br>';
	}
}

function ajax_open_config($file)
{
	if(!@include($file)) _e('<b>Error:</b> file is not within the allowed path, you need to open the file manualy','coppermine'); exit;
	?>
	<table width="100%"><td>
		<input type="button" class="button" onclick="javascript:ajax_copy_config()" value="<--" style="width: 70px; height: 150px;">
	</td><td>
	<table>
	<tr><td align="right"><?PHP _e('Server','coppermine'); ?>:</td>
	<td><input class="button" type="text" id="ajax_cpg_dbserver" value="<?php echo $CONFIG['dbserver']; ?>"></tr>
	<tr><td align="right"><?PHP _e('User','coppermine'); ?>:</td>
	<td><input class="button" type="text" id="ajax_cpg_dbuser" value="<?php echo $CONFIG['dbuser']; ?>"></tr>
	<tr><td align="right"><?PHP _e('Password','coppermine'); ?>:</td>
	<td><input class="button" type="text" id="ajax_cpg_dbpass" value="<?php echo $CONFIG['dbpass']; ?>"></tr>
	<tr><td align="right"><?PHP _e('Database','coppermine'); ?>:</td>
	<td><input class="button" type="text" id="ajax_cpg_dbname" value="<?php echo $CONFIG['dbname']; ?>"></tr>
	<tr><td align="right"><?PHP _e('Table prefix','coppermine'); ?>:</td>
	<td><input class="button" type="text" id="ajax_cpg_table_prefix" value="<?php echo $CONFIG['TABLE_PREFIX']; ?>"></tr>
	</table></td></table>
	<?php
}

/* test database connection */
function window_checkdb_connection()
{
	$r = _connection_test();
	$retval = $r[0];
	$retmsg = $r[1];
	echo $retmsg;
}


/* Test if system is ready for user integration */
function window_check_ui()
{
	$r = _connection_test();
	$retval = $r[0];
	$retmsg = $r[1];

	global $cpg_cmdb;

	if (!$retval) {
		insert_write_span_js( 'checkdb-result-span', $retmsg, true );
		return;
	}

	$r = _user_integration_test();
	$retval = $r[0];
	$retmsg = $r[1];

	if (!$retval) {
		insert_write_span_js( 'checkdb-result-span', $retmsg, true );
		return;
	}

	if (!_wordpress_ok()) {
		insert_write_span_js( 'checkdb-result-span',  __('There is a problem with the database connections. Disable user-integration, and please report this.','coppermine'), true );
		return;
	}

	insert_write_span_js( 'checkdb-result-span', $retmsg, true );
}

/* update database */
function window_updatedb()
{
	global $CPG_CONFIG;

	/* don't do anything if Coppermine is modern */
	if ($CPG_CONFIG['version']>=140) {
		return;
	}
	
	$r = _connection_test();
	$retval = $r[0];
	$retmsg = $r[1];

	/* check db connection */
	if (!$retval) {
		insert_write_span_js( 'updatedb-result-span', $retmsg, true );
		return;
	}

	/* check if already patched */
	$r = _can_patch();
	if (!$r) {
		insert_write_span_js( 'updatedb-result-span', __('The database is up to date and does not need an upgrade.','coppermine'), true );
		return;
	}

	/* backup + upgrade */
	$r = alter_table();
	$retval = $r[0];
	$retmsg = $r[1];

	// alter failed
	if (!$retval) {
		insert_write_span_js( 'updatedb-result-span', $retmsg, true );
		return;
	}

	// double check if update was ok
	$r = _user_integration_succeeded();
	$retval = $r[0];
	$retmsg = $r[1];
	if (!$retval) {
		insert_write_span_js( 'updatedb-result-span', $retmsg, true );
		return;
	}

	// connection to wordpress is borked
	if (!_wordpress_ok()) {
		insert_write_span_js( 'checkdb-result-span', __('There is a problem with the database connections. Disable user-integration, and please report this.','coppermine'), true );
		return;
	}

	insert_write_span_js( 'updatedb-result-span', $retmsg, true );
}

/* restore database backup */
function window_restoredb()
{
	$r = _connection_test();
	$retval = $r[0];
	$retmsg = $r[1];

	if (!$retval) {
		insert_write_span_js( 'restoredb-result-span', $retmsg, true );
		return;
	}
	
	$r = restore_backup();
	$retval = $r[0];
	$retmsg = $r[1];
	
	insert_write_span_js( 'restoredb-result-span', $retmsg, true );
}

/* import WordPress users into CPG */
function window_import_users()
{
	global $wpdb;
	global $CPG_CONFIG;
	global $table_prefix;
	
	/* check db connection */
	$r = _connection_test();
	$retval = $r[0];
	$retmsg = $r[1];

	if (!$retval) {
		insert_write_span_js( 'import-users-result-span', $retmsg, true );
		return;
	}

	/* check if database has been updated */
	$r = _user_integration_test();
	$retval = $r[0];
	$retmsg = $r[1];
	if (!$retval) {
		insert_write_span_js( 'import-users-result-span', $retmsg, true );
		return;
	}

	/* get all WordPress users with level > integration level */
	if ($CPG_CONFIG['version'] < 140) {
		$min_level=intval(get_option('cpg_user_min_level_create'));
		$q = "SELECT * FROM $wpdb->users WHERE user_level > $min_level";
		$wpdb->query($q);
		$users = $wpdb->get_results();
	} else {
		/* In Wp2.0+ we import all active users with roles != subscriber */
		$q = "SELECT * FROM {$wpdb->users} u, {$wpdb->usermeta} m where u.ID = m.user_id and meta_key='".$table_prefix."capabilities'";
		
		$wpdb->query($q);
		$users_tmp = $wpdb->get_results();

		$users = array();
		foreach($users_tmp as $tmp) {
			$caps = unserialize($tmp->meta_value);
			foreach($caps as $cap => $s) {
				fwrite($f,"$cap: $s\n");
			}
			if (!$caps['inactive'] && ($caps['contributor'] || $caps['administrator'] || $caps['editor'] || $caps['author'])) {
				array_push($users, $tmp);
			}
		}
	}

	$i=0;
	//$msg = '';
	if ($users) foreach ($users as $user) {
		if (cpg_import_user($user)) {
			++$i;
			$msg .= $user->user_login.', ';
		}
	}

	if ($i) {
		$msg = substr($msg, 0, -2);
		$msg = "$i ".__('users were imported into the Coppermine user list: ','coppermine').$msg;
	} else {
		$msg = __('No users were imported into the Coppermine user list.','coppermine');
	}

	if ($CPG_CONFIG['version'] < 140) {
		$msg= __('Import of users with level','coppermine')." > $min_level: <br/>".$msg;
	} else {
		$msg= __('Import of users','coppermine').": <br/>".$msg;
	}
	insert_write_span_js( 'import-users-result-span', $msg, true);
}


/*----------------------------------------------------------------------------*/
/*									 TESTS                                    */
/*----------------------------------------------------------------------------*/

// return (true, msg) if can connect
function _connection_test()
{
	require_once('./coppermine.php');

	global $wpdb;
	global $cpg_cmdb;
	global $CPG_CONFIG;

	#print "<h1>Testing connection...</h1>";

	$server = $_GET['s'];
	$user = $_GET['u'];
	$pass = $_GET['p'];
	$db = $_GET['db'];
	$prefix = $_GET['px'];

	$retval = true;
	$retmsg = '';
	
	if (DB_HOST == $server &&
	    DB_USER == $user &&
		DB_PASSWORD == $pass &&
		DB_NAME == $db )
	{
		$cpg_cmdb = new cpg_wpdb_clone($wpdb);
		$retmsg = __(' The database connection is shared with WordPress.','coppermine');
	}
	else {
		$cpg_cmdb = @new cpg_wpdb($server,$user,$pass,$db);
		$retmsg = __(' The database connection is not shared with WordPress.','coppermine');
	}

	if (!$cpg_cmdb || !$cpg_cmdb->dbh) {
		$retval = false;
		$retmsg = __('Can not connect to server or login incorrect. ','coppermine');
	} else {
		// read cpg CONFIG table
		$CPG_CONFIG=array('TABLE_CONFIG' => $prefix.'config');
		$sql="SELECT name, value FROM {$CPG_CONFIG['TABLE_CONFIG']}";
		@$cpg_cmdb->query($sql);
		$results=@$cpg_cmdb->get_results();

		if (count($results) || mysql_num_rows(mysql_query($sql))) {
			$retmsg = __('Connection successful','coppermine').'<br/>'.$retmsg;
		} else {
			# mysql_query($sql);
			
			$retmsg = __('The connection to the database was successful, but the Coppermine tables could not be found. This probably means that the table prefix you entered is invalid. It is usually something like &quot;<code>cpg133_</code>&quot; or &quot;<code>cpg140_</code>&quot;.','coppermine').'<br/>'.$retmsg;
			$retval = false;
		}
	}

	// detect version
	if ($retval) {
		$sestab=get_option('cpg_table_prefix').'sessions';
		$sql="SHOW TABLES LIKE '".$sestab."'";
		if ($sestab==$cpg_cmdb->get_var($sql)) {
			$CPG_CONFIG['version'] = 140;
		} else {
			$CPG_CONFIG['version'] = 130;
		}
	}

	return array($retval, $retmsg);
}

// return (true, msg) if patched 
function _user_integration_test()
{
	global $cpg_cmdb;
	global $CPG_CONFIG;
	

	$q='SELECT * FROM '.$_GET['px'].'users LIMIT 1';
	@$r=$cpg_cmdb->get_row($q, ARRAY_A);
	if (!$r) {
		$retval = false;
		$retmsg = __('Your Coppermine database seems to be corrupt: the users table is not accessible. ','coppermine')."$q";
	} 
	else {
		if ($CPG_CONFIG['version'] < 140) {
			// cpg 1.3
			if (isset($r['user_password_md5'])) {
				$retval = true;
				$retmsg = __('The Coppermine database is ready for user integration and does not need an update. Make sure you have also updated the files in your Coppermine installation.','coppermine');
			}
			else {
				$retval = false;
				$retmsg = __('The Coppermine database needs to be updated. Use the "Upgrade database" link to make it ready for user integration.','coppermine');
			}
		} else {
			// cpg 1.4
			$retval = true;
			$retmsg = __('The Coppermine database is ready for user integration and does not need an update. Make sure you have also updated the files in your Coppermine installation.','coppermine');
		}
	}

	return array($retval, $retmsg);
}

// return (true, msg) if patched 
function _user_integration_succeeded()
{
	global $cpg_cmdb;
	
	$q='SELECT * FROM '.$_GET['px'].'users LIMIT 1';
	@$r=$cpg_cmdb->get_row($q, ARRAY_A);
	if (!$r) {
		$retval = false;
		$retmsg = __('Your Coppermine database seems to be corrupt: the users table is not accessible. ','coppermine')."$q".format_sqlerror();
	} 
	else {
		if ($CPG_CONFIG['version'] < 140) {
			// cpg 1.3
			if (isset($r['user_password_md5'])) {
				$retval = true;
				$retmsg = __('Database upgraded and backup created.','coppermine');
			}
			else {
				$retval = false;
				$retmsg = __('An error occured while updating the database.','coppermine').format_sqlerror();
			}
		} else {
			// cpg 1.4
			$retval = true;
			$retmsg = __('Database ready.','coppermine');
		}
	}

	return array($retval, $retmsg);
}



// return (true, msg) if can upgrade
function _can_patch()
{
	global $cpg_cmdb;
	
	$q='SELECT * FROM '.$_GET['px'].'users LIMIT 1';
	$r=@$cpg_cmdb->get_row($q, ARRAY_A);
	if (!$r) {
		return false;
	} 
	else {
		if (isset($r['user_password_md5'])) {
			return false;
		}
		else {
			return true;
		}
	}
}

// return true if wordpress still works...
function _wordpress_ok()
{
	global $wpdb;

	$q="SELECT * FROM $wpdb->options LIMIT 1";
	return ($wpdb->query($q)>0);
}



/*----------------------------------------------------------------------------*/
/*								DATABASE ACTIONS                              */
/*----------------------------------------------------------------------------*/

function query_failed()
{
	global $EZSQL_ERROR;
	$err=$EZSQL_ERROR[1]; //mysql_error();
	return (!empty($err));
}

function format_sqlerror()
{
	global $EZSQL_ERROR;
	$retmsg='';
	$err=mysql_error();
	if (empty($err)) {
		$err=$EZSQL_ERROR['error_str'];
	}
	if (!empty($err)) {
		$retmsg.='<br/>(mysql: '.htmlspecialchars($err).')';
	}
	return $retmsg;
}


// safe backup: first rename, only drop when everything is in place
function restore_backup()
{
	global $cpg_cmdb;

	$q='SELECT * FROM '.$_GET['px'].'users_backup LIMIT 1';
	if (!$cpg_cmdb->query($q) or query_failed()) {
		return array(false, __('No backup found.','coppermine').format_sqlerror());
	}

	$q='RENAME TABLE '.$_GET['px'].'users TO '.$_GET['px'].'users_temp';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, __('Could not move the modified table away.','coppermine').format_sqlerror());
	}

	$q='RENAME TABLE '.$_GET['px'].'users_backup TO '.$_GET['px'].'users';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, __('Could not restore the table from the backup.','coppermine').format_sqlerror());
	}

	$q='DROP TABLE '.$_GET['px'].'users_temp';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, __('Could not remove the modified table.','coppermine').format_sqlerror());
	}

	return array(true, __('Table restored from backup, and backup removed. You will also need to restore the original files in the Coppermine directory !','coppermine'));
}

// return (true, msg) on success
function alter_table()
{
	global $cpg_cmdb;
	global $CPG_CONFIG;

	if ($CPG_CONFIG['version']>=140) {
		return array(false, __('This version of coppermine does not need an upgrade','coppermine'));
	}

	$q='CREATE TABLE '.$_GET['px'].'users_backup AS SELECT * FROM '.$_GET['px'].'users';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, 'Could not backup the table '.$_GET['px'].'users, do you have sufficient permissions ? '.format_sqlerror());
	}

	$q='ALTER TABLE '.$_GET['px'].'users ADD COLUMN ( user_password_md5 VARCHAR(64) )';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, "Could not modify the ".$GET['px']."users table. Do you have sufficient permissions ?".format_sqlerror() );
	}

	$q='UPDATE '.$_GET['px'].'users SET user_password_md5 = MD5( user_password )';
	if (false===$cpg_cmdb->query($q) or query_failed()) {
		return array(false, __('Could not encode the passwords. You should probably restore the table from the backup.','coppermine').format_sqlerror() );
	}

	return array(true, __('Database upgraded and backup created.','coppermine'));
}

function check_login()
{
	global $user_ID;

	if (!$user_ID) {
		get_currentuserinfo();
	}

	if (!$user_ID) {
	$_GET['redirect_to'] = '%2Fwp-content%2Fplugins%2Fcoppermine%2F';
wp_redirect('../../../wp-login.php');

#		html_head('<h3>Not logged in.</h3>');
#		html_food();
		exit;
	}

	if (function_exists('get_role')) {
		// wp 2.0+
		if (!current_user_can('activate_plugins')) {
wp_redirect('../../../wp-login.php');
/*			html_head('<h3>Not logged in.</h3>
			<h3>You need to be at least a level 8 trampling+flying poweruser</h3>
			<small>Come back when you have more experience points.</small>');
			html_food();
			*/
			exit;
		}
	} else {
		// wp 1.5
		$user=get_userdata($user_ID);
		if ($user->user_level < 8 ) {
wp_redirect('../../../wp-login.php');
/*			html_head('<h3>Not logged in.</h3>
			<h3>You need to be at least a level 8 trampling+flying poweruser</h3>
			<small>Come back when you have more experience points.</small>');
			html_food();*/
			exit;
		}
	}

}

/*----------------------------------------------------------------------------*/
/*									 ROLES                                    */
/*----------------------------------------------------------------------------*/

function update_roles()
{
	// wp 2.0+ only
	if (!function_exists('get_role')) {
		return;
	}

	// don't set default caps if the admin
	// already has cpg caps set.
	$role = get_role('administrator');
	if ($role) {
		if ($role->has_cap('cpg_auto-login') ||
			$role->has_cap('cpg_display_all_pics'))
		{
			return;
		}
	}
	
	// set caps for admin
	if ($role) {
		$role->add_cap('cpg_auto-login');
		$role->add_cap('cpg_display_inserter');
	}

	// set caps for contributor
	$role = get_role('contributor');
	if ($role) {
		$role->add_cap('cpg_auto-login');
		$role->add_cap('cpg_display_inserter');
	}

	// set caps for editor
	$role = get_role('editor');
	if ($role) {
		$role->add_cap('cpg_auto-login');
		$role->add_cap('cpg_display_inserter');
	}

	// set caps for authors
	$role = get_role('author');
	if ($role) {
		$role->add_cap('cpg_auto-login');
		$role->add_cap('cpg_display_inserter');
	}
}


/*----------------------------------------------------------------------------*/
/*									  MAIN                                    */
/*----------------------------------------------------------------------------*/

if(!$_GET['action'])
{
require_once('../wp-blog-header.php');
require_once('../wp-content/plugins/coppermine/coppermine.php');
} else {
require_once('../../../wp-blog-header.php');
require_once('./coppermine.php');
}


check_login();
update_roles();

// dispatcher for popup windows
switch ($_GET['action']) {
	case 'searchcfg':
		ajax_search_config($_GET['root']);
		exit;

case 'opencfg':
		ajax_open_config($_GET['file']);
		exit;

	case 'checkdb':
		window_checkdb_connection();
		exit;

	case 'checkui':
		window_check_ui();
		exit;

	case 'updatedb':
		window_updatedb();
		exit;

	case 'restoredb':
		window_restoredb();
		exit;

	case 'import-users':
		window_import_users();
		exit;
}

// handle actions
if (isset($_POST['uninstall'])) {
	settings_uninstall();
	print <<<UNINST
<html><head><title>Settings removed</title></head><body>
<h1>Settings removed from database. Adios !</h1>
</body><html>
UNINST;
	exit;
}

if (isset($_POST['save']) || 
	isset($_POST['save1']) ||
	isset($_POST['save2'])) {
	settings_save($cpg_options);
	$status =  __('Settings saved.','coppermine');
}

if (isset($_POST['reset'])) {
	settings_reset();
	$status =  __('Settings reset to defaults.','coppermine');
}

if (!settings_are_installed()) {
	$status = __('Default settings created.','coppermine');
	settings_install();
}

if ($settings_version != get_option('cpg_options_version')) {
	$status = __('Settings updated.','coppermine');
	settings_update();
	update_option('cpg_options_version', $settings_version);
}

@cpg_connect();

html_head();
?>
<script type="text/javascript" src="../wp-content/plugins/stimuli-lightbox2/lightbox2/prototype.js"></script>
<?php
config_form($cpg_options);

?>
