<?php
/*
Plugin Name: Coppermine - Lightbox 2
Plugin URI: http://messouvenirs.net/blog/2008/12/21/coppermine-integration-2/
Feed URI: 
Description: Used to overlay images on the current page for Coppermine Integration and more. Lightbox JS v2.2 by <cite><a href="http://www.huddletogether.com/projects/lightbox2/" title="Lightbox JS v2.2 ">Lokesh Dhakar</a>.</cite>
Version: 2.2.3
Author: Rupert Morris
Author URI: http://www.stimuli.ca/
*/

// Traduction of plugins
load_plugin_textdomain('lightbox_2',$loc = 'wp-content/plugins/stimuli-lightbox2/lightbox2/lang/');

/* Where our theme reside: */
$lightbox_2_theme_path = (dirname(__FILE__)."/lightbox2/themes");
update_option('lightbox_2_theme_path', $lightbox_2_theme_path);
/* Set the default theme to Transparent */
add_option('lightbox_2_theme', 'Transparent');
add_option('lightbox_2_automate', 1);

/* options page */
$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=stimuli-lightbox2/options.php';
/* Adds our admin options under "Options" */
function lightbox_2_options_page() {
	add_options_page('Lightbox Options', 'Lightbox 2', 10, 'stimuli-lightbox2/options.php');
}

function lightbox_styles() {
        /* The next lines figures out where the javascripts and images and CSS are installed,
    relative to your wordpress server's root: */
    $lightbox_2_theme_path = (dirname(__FILE__)."/themes");
    $lightbox_2_theme = urldecode(get_option('lightbox_2_theme'));
    $lightbox_style = (get_bloginfo('wpurl')."/wp-content/plugins/stimuli-lightbox2/lightbox2/themes/".$lightbox_2_theme."/");
    $lightbox_path =  get_settings('siteurl')."/wp-content/plugins/stimuli-lightbox2/lightbox2/";

    /* The xhtml header code needed for lightbox to work: */
	$lightboxscript = "\n
	<link rel=\"stylesheet\" href=\"".$lightbox_style."lightbox.css\" type=\"text/css\" media=\"screen\" />\n 
	<script type=\"text/javascript\" src=\"".$lightbox_path."prototype.js\"></script>\n
	<script type=\"text/javascript\" src=\"".$lightbox_path."scriptaculous.js?load=effects\"></script>\n
	<script type=\"text/javascript\" src=\"".$lightbox_path."lightbox.js\"></script>\n";
	/* Output $lightboxscript as text for our web pages: */
	echo($lightboxscript);
}

/* Added a code to automatically insert rel="lightbox[nameofpost]" to every image with no manual work. 
If there are already rel="lightbox[something]" attributes, they are not clobbered. 
Tanin, you are a regular expressions god! ;) 
http://0xtc.com/2008/05/27/auto-lightbox-function.xhtml
*/
function autoexpand_rel_wlightbox ($content) {
	global $post;
	$pattern[0] = "/<a(.*?)href=('|\")([A-Za-z0-9\/_\.\~\:-]*?)(\.bmp|\.gif|\.jpg|\.jpeg|\.png)('|\")([^\>]*?)>/i";
	$pattern[1] = "/<a(.*?)href=('|\")([A-Za-z0-9\/_\.\~\:-]*?)(\.bmp|\.gif|\.jpg|\.jpeg|\.png)('|\")(.*?)(rel=('|\")lightbox(.*?)('|\"))([ \t\r\n\v\f]*?)((rel=('|\")lightbox(.*?)('|\"))?)([ \t\r\n\v\f]?)([^\>]*?)>/i";
	$replacement[0] = '<a$1href=$2$3$4$5$6 rel="lightbox['.$post->ID.']">';
	$replacement[1] = '<a$1href=$2$3$4$5$6$7>';
	$content = preg_replace($pattern, $replacement, $content);
	return $content;
}

if (get_option('lightbox_2_automate') == 1){
	add_filter('the_content', 'autoexpand_rel_wlightbox');
	add_filter('the_excerpt', 'autoexpand_rel_wlightbox');
}

/* we want to add the above xhtml to the header of our pages: */
add_action('wp_head', 'lightbox_styles');
add_action('admin_menu', 'lightbox_2_options_page');
?>